function synthIm = SynthTexture(sample, w, s)
% Texture Synthesis by Non-parameteric Sampling / Efros and Leung

SEED_SIZE = 3;

if ~isa(sample,'double')
    sample = im2double(sample);
end

[sheight,swidth,nChannels] = size(sample);
theight = s(1); twidth = s(2);

synthIm = nan(theight,twidth,nChannels); 

% TODO: G = ...
% G is a 2D zero-mean Gaussian with variance w/6.4 sampled
% on a w x w grid centered about its mean


% Initialization: pick a random 3x3 patch from sample and place in the
% middle of the synthesized image.
% just for convenience, keep some space from the boundary

% i0=32; j0=4;
i0 = round(SEED_SIZE + rand() * (sheight-2*SEED_SIZE));
j0 = round(SEED_SIZE + rand() * (swidth-2*SEED_SIZE));

c = round(.5*s);
synthIm(c(1):c(1)+SEED_SIZE-1,c(2):c(2)+SEED_SIZE-1, :) = ...
                        sample(i0:i0+SEED_SIZE-1, j0:j0+SEED_SIZE-1, :);
    
% bitmap indicating filled pixels
filled = logical(zeros(s));
filled(c(1):c(1)+SEED_SIZE-1,c(2):c(2)+SEED_SIZE-1) = 1;
nFilled = sum(filled(:));
nPixels = prod(s);

% main loop
nextP = nPixels/10;
while nFilled < nPixels
    
    % report progress
    if nFilled > nextP
        fprintf('%d%% complete\n', round(100*nFilled/nPixels));
        nextP = nextP+nPixels/10;
    end
    
    % TODO: find [ii, jj], locations of pixels for next round of filling-in
    % dilate current boundary
    
    
    % permute (just to insert some random noise, this is not a must)
    perm = randperm(length(ii));  
    ii = ii(perm); jj = jj(perm);
    
    for i=1:length(ii)
        
        % TODO: set the correct template
        % place window at the center
        
       
        [bestMatches, errors] = FindMatches(template, sample, G);
        
        % sample from best matches
        pixelValue = bestMatches(:,randi(size(bestMatches,2),1));
        
        % TODO: fill in the value and update parameters
        
        
        
        % uncomment to show texture as it is being synthesized 
%         imshow(synthIm);
%         drawnow;
        
    end
end
